#ifndef __GROUPFROMANNOTATION_H__
#define __GROUPFROMANNOTATION_H__

#include "IntArray.h"
#include "StringBasics.h"
#include "VcfRecord.h"
#include "VcfFileReader.h"
#include "VcfHeader.h"
#include "StringArray.h"
#include "Constant.h"
#include "StringHash.h"

class GroupFromAnnotation
{
    public:
        GroupFromAnnotation();
        ~GroupFromAnnotation();
	
	//Input/Output options	
	static String vcfInput;
	static String groupFile;
	static String function;
	static String freqFile;
	static bool freqOut;

	VcfFileReader reader;
	VcfHeader header;
	VcfRecord record;

	StringArray annoGroups;
	StringArray * chrList;
	StringArray * alleleList;
	IntArray * posList;
	IntArray * startPos;
	IntArray * endPos;
	StringArray * uniqueChr;


	StringDoubleHash markerFreqHash;

	StringIntHash  geneHash;
	StringArray geneChrom;
	std::vector<int> start,end;
	int geneCount;

	//this is the position of each marker in a gene for output

	void GetGroupFromFile();
	void GetGroupFromVCF();
	void Run();

	void GetGroupFromSardiNiaFormat();
	void HashInGenes(std::string & gene);
	void GetAllGenenamesVCF();
	void GetFreqFromFile();
};

#endif
